import ctypes
from ctypes import c_long, c_double, c_short, POINTER
import shutil

class SPdbUSBm:
    def __init__(self, dll_path):
        # DLL Load
        # File path setting
        self.dll = ctypes.WinDLL(dll_path)
        self._setup_functions()

    def _setup_functions(self):
        # spCloseEx function setting
        self.spCloseEx = self.dll.spCloseEx
        self.spCloseEx.restype = c_long

        # spSetIniVarEx function setting 
        self.spSetIniVarEx = self.dll.spSetIniVarEx
        self.spSetIniVarEx.restype = c_long
        self.spSetIniVarEx.argtypes = [c_long]

        # spPolyFit function setting 
        self.spPolyFit = self.dll.spPolyFit
        self.spPolyFit.restype = c_long
        self.spPolyFit.argtypes = [POINTER(c_double), POINTER(c_double), c_short, POINTER(c_double), c_short]

        # spPolyCalc function setting 
        self.spPolyCalc = self.dll.spPolyCalc
        self.spPolyCalc.restype = None
        self.spPolyCalc.argtypes = [POINTER(c_double), c_short, c_double, POINTER(c_double)]

        # spSetIntTimeEx function setting 
        self.spSetIntTimeEx = self.dll.spSetIntTimeEx
        self.spSetIntTimeEx.restype = c_long
        self.spSetIntTimeEx.argtypes = [c_long, c_long]

        # spReadDataEx function setting 
        self.spReadDataEx = self.dll.spReadDataEx
        self.spReadDataEx.restype = c_long
        self.spReadDataEx.argtypes = [c_long, POINTER(c_long)]

        # spTestBoard function setting 
        self.spTestBoard = self.dll.spTestBoard
        self.spTestBoard.restype = c_long

        # spReadStatusTE function setting 
        self.spReadStatusTE = self.dll.spReadStatusTE
        self.spReadStatusTE.restype = c_long
        self.spReadStatusTE.argtypes = [c_long, c_long, POINTER(c_long), POINTER(c_double)]

        # spSetWellDepth function setting 
        self.spSetWellDepth = self.dll.spSetWellDepth
        self.spSetWellDepth.restype = c_long
        self.spSetWellDepth.argtypes = [c_long, c_long]

        # spStoreAllEx function setting 
        self.spStoreAllEx = self.dll.spStoreAllEx
        self.spStoreAllEx.restype = c_long
        self.spStoreAllEx.argtypes = [c_long]

        # spTECoolerPWR function setting 
        self.spTECoolerPWR = self.dll.spTECoolerPWR
        self.spTECoolerPWR.restype = c_long
        self.spTECoolerPWR.argtypes = [c_long, c_long]

        # spSetTECoolerEx function setting 
        self.spSetTECoolerEx = self.dll.spSetTECoolerEx
        self.spSetTECoolerEx.restype = c_long
        self.spSetTECoolerEx.argtypes = [c_long, c_double]

        # spTECoolerReadTECPT function setting 
        self.spTECoolerReadTECPT = self.dll.spTECoolerReadTECPT
        self.spTECoolerReadTECPT.restype = c_long
        self.spTECoolerReadTECPT.argtypes = [c_long, POINTER(c_long)]

        # spSetShutterPos function setting 
        self.spSetShutterPos = self.dll.spSetShutterPos                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
        self.spSetShutterPos.restype = c_long
        self.spSetShutterPos.argtypes = [c_long, c_long]

        # spBalanceEx function setting 
        self.spBalanceEx = self.dll.spBalanceEx
        self.spBalanceEx.restype = c_long
        self.spBalanceEx.argtypes = [c_long, c_long]

        # spConfgTrigger function setting 
        self.spConfgTrigger = self.dll.spConfgTrigger
        self.spConfgTrigger.restype = c_long
        self.spConfgTrigger.argtypes = [c_long, c_long]

        # spConfgTriggerDelay function setting 
        self.spConfgTriggerDelay = self.dll.spConfgTriggerDelay
        self.spConfgTriggerDelay.restype = c_long
        self.spConfgTriggerDelay.argtypes = [c_long, c_long, c_long]

        # spSetExtTrgMode function setting 
        self.spSetExtTrgMode = self.dll.spSetExtTrgMode
        self.spSetExtTrgMode.restype = c_long
        self.spSetExtTrgMode.argtypes = [c_long, c_long]

        # spTECPT_DigToAnal function setting 
        self.spTECPT_DigToAnal = self.dll.spTECPT_DigToAnal
        self.spTECPT_DigToAnal.restype = c_long
        self.spTECPT_DigToAnal.argtypes = [c_long, POINTER(c_double)]

        # spReadDataEx_Raw function setting 
        self.spReadDataEx_Raw = self.dll.spReadDataEx_Raw
        self.spReadDataEx_Raw.restype = c_long
        self.spReadDataEx_Raw.argtypes = [c_long, POINTER(c_long)]

        # spReadDataEx_Adv function setting 
        self.spReadDataEx_Adv = self.dll.spReadDataEx_Adv
        self.spReadDataEx_Adv.restype = c_long
        self.spReadDataEx_Adv.argtypes = [c_long, c_double, ctypes.c_int, POINTER(c_long)]

        self.spGetWLTable = self.dll.spGetWLTable
        self.spGetWLTable.restype = c_long
        self.spGetWLTable.argtypes =[c_long, POINTER(c_double)]


        # Define each function call method
    def spCloseEx(self):
        return self.spCloseEx()

    def spSetIniVarEx(self, lChannel):
        return self.spSetIniVarEx(lChannel)

    def spPolyFit(self, x, y, numPts, coefs, order):
        return self.spPolyFit(x, y, numPts, coefs, order)

    def spPolyCalc(self, coefs, order, x, y):
        self.spPolyCalc(coefs, order, x, y)

    def spSetIntTimeEx(self, lChannel, lIntegTime):
        return self.spSetIntTimeEx(lChannel, lIntegTime)

    def spReadDataEx(self, lChannel, plPixArray):
        return self.spReadDataEx(lChannel, plPixArray)

    def spTestBoard(self):
        return self.spTestBoard()

    def spReadStatusTE(self, lChannel, lNumAvg, lStatusTE, dTeVal):
        return self.spReadStatusTE(lChannel, lNumAvg, lStatusTE, dTeVal)

    def spSetWellDepth(self, lChannel, lWellDepth):
        return self.spSetWellDepth(lChannel, lWellDepth)

    def spStoreAllEx(self, lChannel):
        return self.spStoreAllEx(lChannel)

    def spTECoolerPWR(self, lChannel, lTEPowerState):
        return self.spTECoolerPWR(lChannel, lTEPowerState)

    def spSetTECoolerEx(self, lChannel, dTECTemp):
        return self.spSetTECoolerEx(lChannel, dTECTemp)

    def spTECoolerReadTECPT(self, lChannel, lTECSetpoint):
        return self.spTECoolerReadTECPT(lChannel, lTECSetpoint)

    def spSetShutterPos(self, lChannel, lShutterPos):
        return self.spSetShutterPos(lChannel, lShutterPos)

    def spBalanceEx(self, lChannel, lGlobalSkimOption):
        return self.spBalanceEx(lChannel, lGlobalSkimOption)

    def spConfgTrigger(self, lChannel, lTriggerPolarity):
        return self.spConfgTrigger(lChannel, lTriggerPolarity)

    def spConfgTriggerDelay(self, lChannel, lTrigDelayValue, lTrigDelayMode):
        return self.spConfgTriggerDelay(lChannel, lTrigDelayValue, lTrigDelayMode)

    def spSetExtTrgMode(self, lChannel, lExtTrgState):
        return self.spSetExtTrgMode(lChannel, lExtTrgState)

    def spTECPT_DigToAnal(self, lDTempDig, dTECPointAnal):
        return self.spTECPT_DigToAnal(lDTempDig, dTECPointAnal)

    def spReadDataEx_Raw(self, lChannel, plPixArray):
        return self.spReadDataEx_Raw(lChannel, plPixArray)

    def spReadDataEx_Adv(self, lChannel, dGainValue, iOffsetValue, plPixArray):
        return self.spReadDataEx_Adv(lChannel, dGainValue, iOffsetValue, plPixArray)

    def spGetWLTable(self, IChannel, dWLTable):
        return self.spGetWLTable(IChannel,dWLTable)